% Esercizio 1 del 23 giugno 2017
clear all
close all

% parte a)

% definisco xt con linspace (100 intervalli equispaziati)
xt = linspace (0.1, 1,100);    
% grafico delle funzioni x^2 e -log(x)
% sui punti target xt
plot (xt, xt.^2, 'r', xt, -log(xt), 'b')   
legend ('x^2', '-log(x)');
grid on   % attivo la grid 


% parte b)

% guardando al grafico precedente
% x0=0.5 e' un buon valore iniziale
% uso function handle per definire le funzioni f e fp 
f = @(x) x.^2 + log(x) ;      
fp = @(x) 2*x + 1./x ;
x0=0.5; tol=1.e-8; kmax=20;

[x1, k, err] = Newton(f, fp, x0, tol, kmax);
% Newton converge in k iterazioni e l'errore decresce
% quadraticamente, come da teoria
figure(2)
semilogy(1:k, err)
title ('plot dell''errore metodo di Newton')

% parte c) 

% solo g3(x) puo' essere considerata iterazione di punto fisso
% poiche' si ha \alfa = e ^ (-\alpfa^2) 

%per la convergenza, dobbiamo comunque verificare che
% il modulo della derivata prima della funzione di iterazione
% sia minore di 1 in modulo in tutto l'intervallo
% di convergenza

fiter = @(x) exp(-x.^2);         
dfiter = @(x) -2*x * exp(-x.^2);      % derivata prima

% plot di controllo sulla derivata prima
% usando gli stessi punti equispaziati del punto a)
figure(3)
plot(xt, -2*xt.*exp(-xt.^2),'r-')
title ('plot della derivata di exp(-x^2)')

% parte d) 

tol = 1.e-6;
kmax = 100;
% x0 = 0.5; stesso punto iniziale di a)

[x1, k, err] = MetodoIterativo (fiter, x0, tol, kmax);

% grafico con scala logaritmica sull'ordinata, ascissa ha il numero di
% iterazioni

figure(4)
semilogy( 1:k, err)
title ('plot dell''errore metodo pnto fisso')
% l'errore diminuisce linearmente e il metodo converge 