% Esercizio 2 del 23 giugno 2017

clear all; 
close all;

% punto (a)

A=[7 2 -2 0 0; -3 6 0 1 0; 0 0.5 5 1/3 0; 0 0 -3 5 1; -3 0 0 1 8];
b=A*ones(5,1);
x0=[-1 0 0 0 -1]'; tol=1.e-8; kmax=30;


% ---- Metodo di Jacobi
D=diag(diag(A));
PJ=inv(D)*(D-A);
q=inv(D)*b;

x1=PJ*x0+q;
k=1; err(k)=norm(x1-x0)/norm(x1);

while (err(k) > tol & k <= kmax)
    x0=x1; x1=PJ*x0+q;
    k=k+1;
    err(k)=norm(x1-x0)/norm(x1);
end
if k> kmax
    error('raggiunto il numero massimo d''iterazioni')
else
    disp('la soluzione calcolata e''')
    x1
    semilogy(1:length(err),err); title('Errore relativo Jacobi');
end

% punto (b)
% certamente il metodo di Gauss-Seidel risulta convengente essendo A,
% diagonalmente dominante in senso stretto per righe, che e' il motivo
% per cui converge Jacobi, e convergera' con ordine doppio

% ---- Metodo di Gauss-Seidel
clear err
B=-(tril(A)-D); C=-(triu(A)-D);

PGS=inv(D-B)*C;
q=inv(D-B)*b;
x0=[-1 0 0 0 -1]';
x1=PGS*x0+q;
k=1; err(k)=norm(x1-x0)/norm(x1);

while (err(k) > tol & k <= kmax)
    x0=x1; x1=PGS*x0+q;
    k=k+1;
    err(k)=norm(x1-x0)/norm(x1);
end
if k> kmax
    error('raggiunto il numero massimo d''iterazioni')
else
    disp('la soluzione calcolata e''')
    x1
    figure(2)
    semilogy(1:length(err),err); title('Errore relativo Gauss-Seidel');
end

% Il metodo di GS converge piu' rapidamente perche' il raggio spettrale
% di PGS e' piu' piccolo di quello della matrice di Jacobi PJ
% infatti

disp('raggio spettrale di Gauss-Seidel')
max(abs(eig(PGS)))
disp('raggio spettrale di Jacobi')
max(abs(eig(PJ)))

